# Create a customer

When you create a customer via the API, and the `bvn` is present a digital wallet is automatically created for that customer. If the customer is not a person the you can specify the `add_wallet` query params if you want a wallet attached to the customer.

### URI

&#x20;<mark style="color:blue;background-color:blue;">**POST**</mark>&#x20;

```
https://api.tryduplo.com/v1/wallets/customers?add_wallet={BOOLEAN_VALUE}
```

#### Header

<table data-header-hidden><thead><tr><th width="249"></th><th></th></tr></thead><tbody><tr><td><strong>Authorization</strong><br><code>string</code></td><td>set value to <code>Bearer SECRET_KEY</code></td></tr></tbody></table>

#### Query Param

<table data-header-hidden><thead><tr><th width="248">Key</th><th>Description</th></tr></thead><tbody><tr><td><strong>add_wallet</strong> <br><code>boolean</code> </td><td>Adds a wallet to a customer on the creation of a customer when value is true.</td></tr></tbody></table>

#### Body Param

<table data-header-hidden><thead><tr><th width="250"></th><th></th></tr></thead><tbody><tr><td><strong>business_id</strong><br><code>string</code> <mark style="color:red;"><code>required</code></mark></td><td>Merchant Business ID</td></tr><tr><td><strong>first_name</strong><br><code>string</code> <mark style="color:red;"><code>required</code></mark></td><td>Customer's first name</td></tr><tr><td><strong>last_name</strong><br><code>string</code> <mark style="color:red;"><code>required</code></mark></td><td>Customer's last name</td></tr><tr><td><strong>phone_number</strong><br><code>string</code> <mark style="color:red;"><code>required</code></mark></td><td>Customer's phone number</td></tr><tr><td><strong>email</strong><br><code>string</code> <mark style="color:red;"><code>required</code></mark></td><td>Customer's email address</td></tr><tr><td><strong>bvn</strong><br><code>string</code> </td><td>Customer's bank verification number</td></tr><tr><td><strong>preferred_banks</strong><br><code>array</code></td><td>List of customer's preferred banks</td></tr></tbody></table>

### Sample request

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```
curl --location --request POST 'https://api.tryduplo.com/v1/wallets/customers' \
--header 'Authorization: Bearer dp_live_856879df3e6ecdb14a918e24bba6d480e0564a4eabfdba938fc23b820ac905e54bac25a71dbcdef66c97b8c72ca7e16576857261f2f16f5335ca5024620b14268823a7d78922cfdd97cefc61050139fd92a7a0c580552ccadbbec642d2ff8d35a09225c7ec4fd1e347b' \
--header 'Content-Type: application/json' \
--data-raw '{
    "business_id": "{YOUR VALUE}",
    "first_name": "Jammie",
    "last_name": "Fox",
    "email": "jamefox@yopmail.com",
    "phone_number": "08151740868",
    "business_id": "7e728-74a7-41ce-8a05-310e3e2eba4c",
    "bvn": "22330672110",
    "preferred_banks": [
        { 
            "bank_code": "111", 
            "bank_name": "Wema Bank", 
            "id": "wema" 
        }
    ]
}'
```

{% endcode %}
{% endtab %}

{% tab title="Node" %}
{% code overflow="wrap" lineNumbers="true" %}

```javascript
var axios = require('axios');
var data = JSON.stringify({
  "business_id": "{YOUR_NAME}",
  "first_name": "Jammie",
  "last_name": "Fox",
  "email": "jamefox@yopmail.com",
  "phone_number": "08051740868",
  "business_id": "7e7e0728-74a7-41ce-8a05-e3e2eba4c",
  "bvn": "2233067210",
  "preferred_banks": [
    {
      "bank_code": "111",
      "bank_name": "Wema Bank",
      "id": "wema"
    }
  ]
});

var config = {
  method: 'post',
  url: 'https://api.tryduplo.com/v1/wallets/customers',
  headers: { 
    'Authorization': 'Bearer dp_live_856879df3e6ecdb14a918e24bba6d480e0564a4eadba938fc23b820ac905e54bac25a71dbcdef66c97b8c72ca7e16cf03a576857335ca5024620b14268823a7d78922cfdd97cefc61050139fd92a7a0c5840e016050552ccadbbec642d2ff8d35a09225c7ec4fd1e347b', 
    'Content-Type': 'application/json'
  },
  data: data
};

axios(config)
.then(function (response) {
  console.log(JSON.stringify(response.data));
})
.catch(function (error) {
  console.log(error);
});

```

{% endcode %}
{% endtab %}

{% tab title="PHP" %}
{% code overflow="wrap" lineNumbers="true" %}

```php
$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://api.tryduplo.com/v1/wallets/customers',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>'{
    "business_id": "{YOUR_NAME}",
    "first_name": "Jammie",
    "last_name": "Fox",
    "email": "jamefox@yopmail.com",
    "phone_number": "08051740861",
    "business_id": "7e7e07-74a7-41ce-8a05-310e3e2eba4c",
    "bvn": "2233067110",
    "preferred_banks": [
        { 
            "bank_code": "111", 
            "bank_name": "Wema Bank", 
            "id": "wema" 
        }
    ]
}',
  CURLOPT_HTTPHEADER => array(
    'Authorization: Bearer dp_live_856879df3e6ecdb14a918e24bba6d480e0564a4eabfdba938fc23b820ac905e54bac25a71dbcdef66c97b8c72ca7e16cf016f5335ca5024620b14268823a7d78922cfdd97cefc61050139fd92a7a0c5840e016050552ccadbbec642d2ff8d09225c7ec4fd1e347b',
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
echo $response;
```

{% endcode %}
{% endtab %}
{% endtabs %}

### Duplo Response

```json
{
    "data": {
        "wallets": [
            {
                "currency": "NGN",
                "ledger_balance": 0,
                "available_balance": 0,
                "opening_balance": 0,
                "closing_balance": 0,
                "is_master": false,
                "bank_accounts": [
                    {
                        "_id": "63d8b3084e6de5000dee6c3d",
                        "provider": {
                            "id": "wema",
                            "bank_code": "111",
                            "bank_name": "Wema Bank",
                            "is_prefix": true,
                            "requires_bvn": false,
                            "prefixes": [
                                "809"
                            ],
                            "fixed_amount_prefixes": [
                                "841"
                            ],
                            "default": true
                        },
                        "account_number": "8090025677",
                        "account_name": "Jammie Fox"
                    }
                ],
                "status": "Active",
                "notes": [],
                "business_id": "986acd67-b306-4642-87aa-99ba512b2601",
                "wallet_ref": "wal_vkIXjqrHwKgl",
                "created_at": "2023-01-31T06:19:52.000Z",
                "email": "jamefox@yopmail.com",
                "metadata": "{}",
                "updated_at": "2023-01-31T06:19:52.329Z",
                "customer": "63d8b307dfbff6000d03d817"
            }
        ],
        "first_name": "Jammie",
        "last_name": "Fox",
        "email": "jamefox@yopmail.com",
        "phone_number": "08051740860",
        "business_id": "986acd67-b306-4642-87aa-99ba512b2601",
        "customer_ref": "cus_4GR7iiAfUaRU",
        "created_at": "2023-01-31T06:19:51.555Z",
        "updated_at": "2023-01-31T06:19:52.316Z"
    },
    "errors": {},
    "message": "Request successful"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.tryduplo.com/duplo-api-documentation/payment-apis/collect-payments/customers/create-a-customer.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
